<?php
ini_set('display_errors', 1); 
error_reporting(E_ALL ^ E_NOTICE);
$access_token = "EAAAEADYSRGarhx3rK9PkD9X76-E6QNbNRRO9VtOyAof8ghC7aJLg1ZxoG-xijsv";

// Note this line needs to change if you don't use Composer:
// require('square-php-sdk/autoload.php');
require 'autoload.php';
// require_once '/home/sytistcom/public_html/subfolderinstall/sy-inc/store/payment/square-web-payments/unirest-php/src/Unirest.php';
// include 'utils/location-info.php';

use Dotenv\Dotenv;
use Square\SquareClient;
use Square\Models\Money;
use Square\Models\CreatePaymentRequest;
use Square\Exceptions\ApiException;
use Ramsey\Uuid\Uuid;
use Square\Environment;
// dotenv is used to read from the '.env' file created for credentials
// $dotenv = Dotenv::create(__DIR__);
// $dotenv->load();

if ($_SERVER['REQUEST_METHOD'] != 'POST') {
  error_log('Received a non-POST request');
  echo 'Request not allowed';
  http_response_code(405);
  return;
}

$json = file_get_contents('php://input');
$data = json_decode($json,true);
$token = $data->token;

$square_client = new SquareClient([
  'accessToken' => $access_token,
  'environment' => Environment::SANDBOX,
]);

$payments_api = $square_client->getPaymentsApi();

// To learn more about splitting payments with additional recipients,
// see the Payments API documentation on our [developer site]
// (https://developer.squareup.com/docs/payments-api/overview).

$money = new Money();
// Monetary amounts are specified in the smallest unit of the applicable currency.
// This amount is in cents. It's also hard-coded for $1.00, which isn't very useful.
$money->setAmount(100);
// Set currency to the currency for the location
$money->setCurrency($location_info->getCurrency());

try {
// Every payment you process with the SDK must have a unique idempotency key.
// If you're unsure whether a particular payment succeeded, you can reattempt
// it with the same idempotency key without worrying about double charging
// the buyer.
  $create_payment_request = new CreatePaymentRequest($token, Uuid::uuid4(), $money);

  $response = $payments_api->createPayment($create_payment_request);

  if ($response->isSuccess()) {
    echo json_encode($response->getResult());
  } else {
    echo json_encode(array('errors' => $response->getErrors()));
  }
} catch (ApiException $e) {
  echo json_encode(array('errors' => $e));
}